/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "grammar.y"


#include "config.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdint.h>
#include <netinet/in.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>

#include "util.h"
#include "output_util.h"
#include "rbtree.h"
#include "filter.h"
#include "nfdump.h"
#include "nffile.h"
#include "nftree.h"
#include "ipconv.h"
#include "sgregex/sgregex.h"

#define AnyMask 0xffffffffffffffffLL

/*
 * function prototypes
 */
static void  yyerror(char *msg);

static uint32_t ChainHosts(uint64_t *offsets, uint64_t *hostlist, int num_records, int type);

static uint64_t VerifyMac(char *s);

static int InitSymbols(void);

static uint32_t Get_fwd_status_id(char *status);

static char *stripWord(char *word);

static int IsMD5(char *string);

enum { DIR_UNSPEC = 1, 
	   SOURCE, DESTINATION, SOURCE_AND_DESTINATION, SOURCE_OR_DESTINATION, 
	   DIR_IN, DIR_OUT, 
	   IN_SRC, IN_DST, OUT_SRC, OUT_DST, 
	   ADJ_PREV, ADJ_NEXT };

enum { IS_START = 0, IS_END };

/* var defs */
extern int 			lineno;
extern char 		*yytext;
extern uint64_t		*IPstack;
extern uint32_t	StartNode;
extern uint8_t	geoFilter;
extern uint8_t	ja3Filter;
extern int (*FilterEngine)(uint32_t *);
extern char	*FilterFilename;

static uint32_t num_ip;

static struct fwd_status_def_s {
	uint32_t	id;
	char		*name;
} fwd_status_def_list[] = {
	{ 0,	"Ukwn"}, 	// Unknown
	{ 1,	"Forw"}, 	// Normal forwarding
	{ 2,	"Frag"}, 	// Fragmented
	{ 16,	"Drop"}, 	// Drop
	{ 17,	"DaclD"},	// Drop ACL deny
	{ 18,	"Daclp"},	// Drop ACL drop
	{ 19,	"Noroute"},	// Unroutable
	{ 20,	"Dadj"}, 	// Drop Adjacency
	{ 21,	"Dfrag"}, 	// Drop Fragmentation & DF set
	{ 22,	"Dbadh"}, 	// Drop Bad header checksum
	{ 23,	"Dbadtlen"}, // Drop Bad total Length
	{ 24,	"Dbadhlen"}, // Drop Bad Header Length
	{ 25,	"DbadTTL"}, // Drop bad TTL
	{ 26,	"Dpolicy"}, // Drop Policer
	{ 27,	"Dwred"}, 	// Drop WRED
	{ 28,	"Drpf"}, 	// Drop RPF
	{ 29,	"Dforus"}, 	// Drop For us
	{ 30,	"DbadOf"}, 	// Drop Bad output interface
	{ 31,	"Dhw"}, 	// Drop Hardware
	{ 128,	"Term"}, 	// Terminate
	{ 129,	"Tadj"}, 	// Terminate Punt Adjacency
	{ 130,	"TincAdj"}, // Terminate Incomplete Adjacency
	{ 131,	"Tforus"}, 	// Terminate For us
	{ 0,	NULL}		// Last entry
};

static char **fwd_status = NULL;

char yyerror_buff[256];

#define MPLSMAX 0x00ffffff

#line 171 "grammar.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_GRAMMAR_H_INCLUDED
# define YY_YY_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    ANY = 258,                     /* ANY  */
    IP = 259,                      /* IP  */
    TUNIP = 260,                   /* TUNIP  */
    IF = 261,                      /* IF  */
    MAC = 262,                     /* MAC  */
    MPLS = 263,                    /* MPLS  */
    TOS = 264,                     /* TOS  */
    DIR = 265,                     /* DIR  */
    FLAGS = 266,                   /* FLAGS  */
    TUN = 267,                     /* TUN  */
    PROTO = 268,                   /* PROTO  */
    MASK = 269,                    /* MASK  */
    NET = 270,                     /* NET  */
    PORT = 271,                    /* PORT  */
    FWDSTAT = 272,                 /* FWDSTAT  */
    IN = 273,                      /* IN  */
    OUT = 274,                     /* OUT  */
    SRC = 275,                     /* SRC  */
    DST = 276,                     /* DST  */
    EQ = 277,                      /* EQ  */
    LT = 278,                      /* LT  */
    GT = 279,                      /* GT  */
    LE = 280,                      /* LE  */
    GE = 281,                      /* GE  */
    PREV = 282,                    /* PREV  */
    NEXT = 283,                    /* NEXT  */
    IDENT = 284,                   /* IDENT  */
    ENGINE_TYPE = 285,             /* ENGINE_TYPE  */
    ENGINE_ID = 286,               /* ENGINE_ID  */
    EXPORTER = 287,                /* EXPORTER  */
    AS = 288,                      /* AS  */
    GEO = 289,                     /* GEO  */
    PACKETS = 290,                 /* PACKETS  */
    BYTES = 291,                   /* BYTES  */
    FLOWS = 292,                   /* FLOWS  */
    LABEL = 293,                   /* LABEL  */
    NFVERSION = 294,               /* NFVERSION  */
    COUNT = 295,                   /* COUNT  */
    PPS = 296,                     /* PPS  */
    BPS = 297,                     /* BPS  */
    BPP = 298,                     /* BPP  */
    DURATION = 299,                /* DURATION  */
    NOT = 300,                     /* NOT  */
    IPV4 = 301,                    /* IPV4  */
    IPV6 = 302,                    /* IPV6  */
    BGPNEXTHOP = 303,              /* BGPNEXTHOP  */
    ROUTER = 304,                  /* ROUTER  */
    VLAN = 305,                    /* VLAN  */
    CLIENT = 306,                  /* CLIENT  */
    SERVER = 307,                  /* SERVER  */
    APP = 308,                     /* APP  */
    LATENCY = 309,                 /* LATENCY  */
    SYSID = 310,                   /* SYSID  */
    ASA = 311,                     /* ASA  */
    DENIED = 312,                  /* DENIED  */
    XEVENT = 313,                  /* XEVENT  */
    XNET = 314,                    /* XNET  */
    XPORT = 315,                   /* XPORT  */
    INGRESS = 316,                 /* INGRESS  */
    EGRESS = 317,                  /* EGRESS  */
    ACL = 318,                     /* ACL  */
    ACE = 319,                     /* ACE  */
    XACE = 320,                    /* XACE  */
    NAT = 321,                     /* NAT  */
    ADD = 322,                     /* ADD  */
    EVENT = 323,                   /* EVENT  */
    VRF = 324,                     /* VRF  */
    NPORT = 325,                   /* NPORT  */
    NIP = 326,                     /* NIP  */
    PBLOCK = 327,                  /* PBLOCK  */
    START = 328,                   /* START  */
    END = 329,                     /* END  */
    STEP = 330,                    /* STEP  */
    SIZE = 331,                    /* SIZE  */
    PAYLOAD = 332,                 /* PAYLOAD  */
    CONTENT = 333,                 /* CONTENT  */
    REGEX = 334,                   /* REGEX  */
    JA3 = 335,                     /* JA3  */
    OBSERVATION = 336,             /* OBSERVATION  */
    DOMAIN = 337,                  /* DOMAIN  */
    POINT = 338,                   /* POINT  */
    ID = 339,                      /* ID  */
    PF = 340,                      /* PF  */
    PFACTION = 341,                /* PFACTION  */
    PFREASON = 342,                /* PFREASON  */
    RULE = 343,                    /* RULE  */
    INTERFACE = 344,               /* INTERFACE  */
    STRING = 345,                  /* STRING  */
    WORD = 346,                    /* WORD  */
    REASON = 347,                  /* REASON  */
    NUMBER = 348,                  /* NUMBER  */
    PORTNUM = 349,                 /* PORTNUM  */
    ICMP_TYPE = 350,               /* ICMP_TYPE  */
    ICMP_CODE = 351,               /* ICMP_CODE  */
    OR = 352,                      /* OR  */
    AND = 353,                     /* AND  */
    NEGATE = 354                   /* NEGATE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define ANY 258
#define IP 259
#define TUNIP 260
#define IF 261
#define MAC 262
#define MPLS 263
#define TOS 264
#define DIR 265
#define FLAGS 266
#define TUN 267
#define PROTO 268
#define MASK 269
#define NET 270
#define PORT 271
#define FWDSTAT 272
#define IN 273
#define OUT 274
#define SRC 275
#define DST 276
#define EQ 277
#define LT 278
#define GT 279
#define LE 280
#define GE 281
#define PREV 282
#define NEXT 283
#define IDENT 284
#define ENGINE_TYPE 285
#define ENGINE_ID 286
#define EXPORTER 287
#define AS 288
#define GEO 289
#define PACKETS 290
#define BYTES 291
#define FLOWS 292
#define LABEL 293
#define NFVERSION 294
#define COUNT 295
#define PPS 296
#define BPS 297
#define BPP 298
#define DURATION 299
#define NOT 300
#define IPV4 301
#define IPV6 302
#define BGPNEXTHOP 303
#define ROUTER 304
#define VLAN 305
#define CLIENT 306
#define SERVER 307
#define APP 308
#define LATENCY 309
#define SYSID 310
#define ASA 311
#define DENIED 312
#define XEVENT 313
#define XNET 314
#define XPORT 315
#define INGRESS 316
#define EGRESS 317
#define ACL 318
#define ACE 319
#define XACE 320
#define NAT 321
#define ADD 322
#define EVENT 323
#define VRF 324
#define NPORT 325
#define NIP 326
#define PBLOCK 327
#define START 328
#define END 329
#define STEP 330
#define SIZE 331
#define PAYLOAD 332
#define CONTENT 333
#define REGEX 334
#define JA3 335
#define OBSERVATION 336
#define DOMAIN 337
#define POINT 338
#define ID 339
#define PF 340
#define PFACTION 341
#define PFREASON 342
#define RULE 343
#define INTERFACE 344
#define STRING 345
#define WORD 346
#define REASON 347
#define NUMBER 348
#define PORTNUM 349
#define ICMP_TYPE 350
#define ICMP_CODE 351
#define OR 352
#define AND 353
#define NEGATE 354

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 132 "grammar.y"

	uint64_t		value;
	char			*s;
	FilterParam_t	param;
	void			*list;

#line 429 "grammar.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_GRAMMAR_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ANY = 3,                        /* ANY  */
  YYSYMBOL_IP = 4,                         /* IP  */
  YYSYMBOL_TUNIP = 5,                      /* TUNIP  */
  YYSYMBOL_IF = 6,                         /* IF  */
  YYSYMBOL_MAC = 7,                        /* MAC  */
  YYSYMBOL_MPLS = 8,                       /* MPLS  */
  YYSYMBOL_TOS = 9,                        /* TOS  */
  YYSYMBOL_DIR = 10,                       /* DIR  */
  YYSYMBOL_FLAGS = 11,                     /* FLAGS  */
  YYSYMBOL_TUN = 12,                       /* TUN  */
  YYSYMBOL_PROTO = 13,                     /* PROTO  */
  YYSYMBOL_MASK = 14,                      /* MASK  */
  YYSYMBOL_NET = 15,                       /* NET  */
  YYSYMBOL_PORT = 16,                      /* PORT  */
  YYSYMBOL_FWDSTAT = 17,                   /* FWDSTAT  */
  YYSYMBOL_IN = 18,                        /* IN  */
  YYSYMBOL_OUT = 19,                       /* OUT  */
  YYSYMBOL_SRC = 20,                       /* SRC  */
  YYSYMBOL_DST = 21,                       /* DST  */
  YYSYMBOL_EQ = 22,                        /* EQ  */
  YYSYMBOL_LT = 23,                        /* LT  */
  YYSYMBOL_GT = 24,                        /* GT  */
  YYSYMBOL_LE = 25,                        /* LE  */
  YYSYMBOL_GE = 26,                        /* GE  */
  YYSYMBOL_PREV = 27,                      /* PREV  */
  YYSYMBOL_NEXT = 28,                      /* NEXT  */
  YYSYMBOL_IDENT = 29,                     /* IDENT  */
  YYSYMBOL_ENGINE_TYPE = 30,               /* ENGINE_TYPE  */
  YYSYMBOL_ENGINE_ID = 31,                 /* ENGINE_ID  */
  YYSYMBOL_EXPORTER = 32,                  /* EXPORTER  */
  YYSYMBOL_AS = 33,                        /* AS  */
  YYSYMBOL_GEO = 34,                       /* GEO  */
  YYSYMBOL_PACKETS = 35,                   /* PACKETS  */
  YYSYMBOL_BYTES = 36,                     /* BYTES  */
  YYSYMBOL_FLOWS = 37,                     /* FLOWS  */
  YYSYMBOL_LABEL = 38,                     /* LABEL  */
  YYSYMBOL_NFVERSION = 39,                 /* NFVERSION  */
  YYSYMBOL_COUNT = 40,                     /* COUNT  */
  YYSYMBOL_PPS = 41,                       /* PPS  */
  YYSYMBOL_BPS = 42,                       /* BPS  */
  YYSYMBOL_BPP = 43,                       /* BPP  */
  YYSYMBOL_DURATION = 44,                  /* DURATION  */
  YYSYMBOL_NOT = 45,                       /* NOT  */
  YYSYMBOL_IPV4 = 46,                      /* IPV4  */
  YYSYMBOL_IPV6 = 47,                      /* IPV6  */
  YYSYMBOL_BGPNEXTHOP = 48,                /* BGPNEXTHOP  */
  YYSYMBOL_ROUTER = 49,                    /* ROUTER  */
  YYSYMBOL_VLAN = 50,                      /* VLAN  */
  YYSYMBOL_CLIENT = 51,                    /* CLIENT  */
  YYSYMBOL_SERVER = 52,                    /* SERVER  */
  YYSYMBOL_APP = 53,                       /* APP  */
  YYSYMBOL_LATENCY = 54,                   /* LATENCY  */
  YYSYMBOL_SYSID = 55,                     /* SYSID  */
  YYSYMBOL_ASA = 56,                       /* ASA  */
  YYSYMBOL_DENIED = 57,                    /* DENIED  */
  YYSYMBOL_XEVENT = 58,                    /* XEVENT  */
  YYSYMBOL_XNET = 59,                      /* XNET  */
  YYSYMBOL_XPORT = 60,                     /* XPORT  */
  YYSYMBOL_INGRESS = 61,                   /* INGRESS  */
  YYSYMBOL_EGRESS = 62,                    /* EGRESS  */
  YYSYMBOL_ACL = 63,                       /* ACL  */
  YYSYMBOL_ACE = 64,                       /* ACE  */
  YYSYMBOL_XACE = 65,                      /* XACE  */
  YYSYMBOL_NAT = 66,                       /* NAT  */
  YYSYMBOL_ADD = 67,                       /* ADD  */
  YYSYMBOL_EVENT = 68,                     /* EVENT  */
  YYSYMBOL_VRF = 69,                       /* VRF  */
  YYSYMBOL_NPORT = 70,                     /* NPORT  */
  YYSYMBOL_NIP = 71,                       /* NIP  */
  YYSYMBOL_PBLOCK = 72,                    /* PBLOCK  */
  YYSYMBOL_START = 73,                     /* START  */
  YYSYMBOL_END = 74,                       /* END  */
  YYSYMBOL_STEP = 75,                      /* STEP  */
  YYSYMBOL_SIZE = 76,                      /* SIZE  */
  YYSYMBOL_PAYLOAD = 77,                   /* PAYLOAD  */
  YYSYMBOL_CONTENT = 78,                   /* CONTENT  */
  YYSYMBOL_REGEX = 79,                     /* REGEX  */
  YYSYMBOL_JA3 = 80,                       /* JA3  */
  YYSYMBOL_OBSERVATION = 81,               /* OBSERVATION  */
  YYSYMBOL_DOMAIN = 82,                    /* DOMAIN  */
  YYSYMBOL_POINT = 83,                     /* POINT  */
  YYSYMBOL_ID = 84,                        /* ID  */
  YYSYMBOL_PF = 85,                        /* PF  */
  YYSYMBOL_PFACTION = 86,                  /* PFACTION  */
  YYSYMBOL_PFREASON = 87,                  /* PFREASON  */
  YYSYMBOL_RULE = 88,                      /* RULE  */
  YYSYMBOL_INTERFACE = 89,                 /* INTERFACE  */
  YYSYMBOL_STRING = 90,                    /* STRING  */
  YYSYMBOL_WORD = 91,                      /* WORD  */
  YYSYMBOL_REASON = 92,                    /* REASON  */
  YYSYMBOL_NUMBER = 93,                    /* NUMBER  */
  YYSYMBOL_PORTNUM = 94,                   /* PORTNUM  */
  YYSYMBOL_ICMP_TYPE = 95,                 /* ICMP_TYPE  */
  YYSYMBOL_ICMP_CODE = 96,                 /* ICMP_CODE  */
  YYSYMBOL_97_ = 97,                       /* '+'  */
  YYSYMBOL_OR = 98,                        /* OR  */
  YYSYMBOL_99_ = 99,                       /* '*'  */
  YYSYMBOL_AND = 100,                      /* AND  */
  YYSYMBOL_NEGATE = 101,                   /* NEGATE  */
  YYSYMBOL_102_ = 102,                     /* '['  */
  YYSYMBOL_103_ = 103,                     /* ']'  */
  YYSYMBOL_104_ = 104,                     /* '/'  */
  YYSYMBOL_105_ = 105,                     /* ','  */
  YYSYMBOL_106_ = 106,                     /* '('  */
  YYSYMBOL_107_ = 107,                     /* ')'  */
  YYSYMBOL_108_ = 108,                     /* '%'  */
  YYSYMBOL_YYACCEPT = 109,                 /* $accept  */
  YYSYMBOL_prog = 110,                     /* prog  */
  YYSYMBOL_term = 111,                     /* term  */
  YYSYMBOL_iplist = 112,                   /* iplist  */
  YYSYMBOL_ullist = 113,                   /* ullist  */
  YYSYMBOL_comp = 114,                     /* comp  */
  YYSYMBOL_dqual = 115,                    /* dqual  */
  YYSYMBOL_inout = 116,                    /* inout  */
  YYSYMBOL_acl = 117,                      /* acl  */
  YYSYMBOL_expr = 118                      /* expr  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  122
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   362

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  109
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  133
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  286

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   354


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   108,     2,     2,
     106,   107,    99,    97,   105,     2,     2,   104,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   102,     2,   103,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    98,   100,   101
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   161,   161,   162,   167,   171,   181,   186,   191,   207,
     222,   238,   254,   272,   289,   293,   297,   301,   305,   309,
     313,   345,   353,   365,   377,   407,   453,   499,   527,   554,
     560,   587,   614,   618,   622,   626,   634,   667,   675,   683,
     694,   705,   716,   732,   736,   740,   744,   771,   834,   849,
     864,   872,   880,   889,   898,   922,   935,   955,   979,   992,
    1082,  1120,  1160,  1178,  1193,  1206,  1219,  1232,  1245,  1283,
    1335,  1343,  1352,  1369,  1386,  1418,  1450,  1490,  1536,  1601,
    1634,  1724,  1809,  1835,  1868,  1930,  2085,  2099,  2107,  2118,
    2127,  2142,  2146,  2151,  2194,  2248,  2279,  2311,  2355,  2376,
    2387,  2401,  2402,  2403,  2404,  2405,  2406,  2410,  2411,  2412,
    2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,  2422,
    2423,  2424,  2427,  2428,  2431,  2432,  2433,  2436,  2437,  2438,
    2439,  2440,  2441,  2450
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ANY", "IP", "TUNIP",
  "IF", "MAC", "MPLS", "TOS", "DIR", "FLAGS", "TUN", "PROTO", "MASK",
  "NET", "PORT", "FWDSTAT", "IN", "OUT", "SRC", "DST", "EQ", "LT", "GT",
  "LE", "GE", "PREV", "NEXT", "IDENT", "ENGINE_TYPE", "ENGINE_ID",
  "EXPORTER", "AS", "GEO", "PACKETS", "BYTES", "FLOWS", "LABEL",
  "NFVERSION", "COUNT", "PPS", "BPS", "BPP", "DURATION", "NOT", "IPV4",
  "IPV6", "BGPNEXTHOP", "ROUTER", "VLAN", "CLIENT", "SERVER", "APP",
  "LATENCY", "SYSID", "ASA", "DENIED", "XEVENT", "XNET", "XPORT",
  "INGRESS", "EGRESS", "ACL", "ACE", "XACE", "NAT", "ADD", "EVENT", "VRF",
  "NPORT", "NIP", "PBLOCK", "START", "END", "STEP", "SIZE", "PAYLOAD",
  "CONTENT", "REGEX", "JA3", "OBSERVATION", "DOMAIN", "POINT", "ID", "PF",
  "PFACTION", "PFREASON", "RULE", "INTERFACE", "STRING", "WORD", "REASON",
  "NUMBER", "PORTNUM", "ICMP_TYPE", "ICMP_CODE", "'+'", "OR", "'*'", "AND",
  "NEGATE", "'['", "']'", "'/'", "','", "'('", "')'", "'%'", "$accept",
  "prog", "term", "iplist", "ullist", "comp", "dqual", "inout", "acl",
  "expr", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-188)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     136,  -188,    13,   -44,    22,    27,   -70,   -32,    90,   105,
      37,    42,  -188,    69,    11,   299,   299,   299,   299,    26,
     299,   299,   299,   299,   299,   299,   235,  -188,  -188,    84,
     126,    91,    98,   104,    66,     1,    92,    93,   101,    32,
       4,   -58,    -8,    67,    77,   235,    96,   190,  -188,   200,
      50,    43,   100,   299,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,   102,   -16,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,   173,   175,   179,   180,   -15,
    -188,   108,   110,   117,   118,  -188,   119,   125,   127,   129,
     135,   137,  -188,   139,   147,   299,   299,   299,  -188,   299,
       7,   299,   299,    12,   299,   299,   299,   299,   -28,   148,
     150,   157,   165,   132,   -39,   161,   164,   168,  -188,  -188,
       2,   155,  -188,   -14,   178,   176,   195,   299,   196,   202,
     201,   280,   203,   299,   299,   206,   204,   299,   299,     8,
    -188,  -188,  -188,   299,   235,   235,  -188,   207,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,   193,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,   215,
     216,   217,   218,   -40,  -188,   220,   221,   222,  -188,   224,
     225,   226,   233,   234,  -188,  -188,   238,  -188,   236,   239,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,   227,   235,   231,
    -188,  -188,  -188,  -188,   241,  -188,   -62,   -63,   243,   237,
     244,  -188,   245,   247,  -188,   240,   249,   252,   246,  -188,
     253,   250,  -188,  -188,   257,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,   259,    31,   257,  -188,  -188,   258,  -188,   260,
    -188,   260,  -188,  -188,  -188,   261,  -188,  -188,   257,  -188,
     248,   -49,  -188,  -188,   -38,  -188,  -188,   -33,    29,  -188,
     -37,   262,   254,  -188,   266,  -188,  -188,  -188,   264,  -188,
    -188,  -188,   267,  -188,  -188,  -188
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
     107,     4,     0,     0,   101,     0,     0,     0,   114,   115,
     108,   109,   120,   121,     0,   101,   101,   101,   101,     0,
     101,   101,   101,   101,   101,   101,   107,     6,     7,     0,
       0,     0,     0,     0,     0,     0,   122,   123,     0,     0,
       0,     0,     0,     0,     0,   107,     0,     0,   127,     0,
       0,     3,     0,   101,   122,   123,    89,    90,   102,   103,
     104,   105,   106,    23,    24,     0,     0,     9,     8,    88,
      87,   116,   117,   118,   119,     0,     0,     0,     0,     0,
       5,     0,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,   130,     0,     0,   101,   101,   101,    35,   101,
     101,   101,   101,   101,   101,   101,   101,   101,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    48,    49,
       0,     0,     1,     0,     0,     0,     0,   101,     0,     0,
     101,   101,     0,   101,   101,     0,     0,   101,   101,     0,
     124,   125,   126,   101,   107,   107,    86,     0,    22,    11,
      10,   110,   112,   111,   113,     0,    28,    50,    51,    52,
      14,    21,    19,    15,    16,    17,    18,    30,    31,     0,
       0,     0,     0,     0,    54,     0,     0,     0,    62,     0,
       0,     0,     0,     0,    70,    71,    72,    74,     0,     0,
      44,    45,    40,    39,    41,    43,    42,   131,   107,     0,
      25,    26,    82,    84,     0,    79,     0,     0,     0,     0,
       0,    77,     0,     0,    83,     0,     0,     0,     0,    69,
       0,   128,   129,    85,     0,    32,    33,    34,    58,    57,
      56,    55,    37,    38,    63,    64,    65,    66,    67,    73,
      91,    92,     0,     0,     0,    20,    80,     0,    46,     0,
      36,     0,    76,    12,    13,     0,    60,    68,     0,    61,
      93,     0,   132,   133,     0,    81,    98,     0,     0,    59,
       0,     0,    95,    29,     0,    27,    99,    47,     0,    78,
      75,    94,     0,    96,   100,    97
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -188,  -188,  -188,  -187,   111,   -10,  -188,    -2,  -188,   -26
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    47,    48,   261,   267,    65,    49,    50,   143,    51
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      92,    57,   113,   155,   199,    81,    82,    83,    84,   248,
      86,    87,    88,    89,    90,    91,    52,    54,    55,   120,
      67,    54,    55,    68,   111,   112,   218,   192,   246,    58,
      59,    60,    61,    62,    58,    59,    60,    61,    62,   249,
      66,   272,   247,   147,    58,    59,    60,    61,    62,    56,
     229,   193,   272,   272,   273,    63,   274,   264,    69,    99,
     276,    70,   184,   185,   173,   275,   280,   274,   274,   100,
     277,   270,   278,    79,   149,   156,   200,   150,   114,   115,
     116,   117,   108,   109,   110,   169,   170,   171,    93,   172,
     175,   176,   177,   179,   180,   181,   182,   183,   219,   174,
     144,    80,   145,    53,   178,   104,   105,   106,   107,   197,
      71,    72,    64,   140,   141,   142,    85,   204,   221,   222,
     208,   210,   276,   212,   213,    73,    74,   216,   217,   144,
      94,   145,   279,   220,   278,    75,    -2,    76,   263,     1,
      77,   144,    78,   145,     2,    95,     3,     4,     5,     6,
     190,   191,    96,     7,     8,     9,    10,    11,    97,    98,
     118,   101,   102,    12,    13,    14,    15,    16,    17,   103,
     119,   230,   243,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   121,    31,    32,    33,
     122,    34,    35,   146,   151,   148,   152,    36,    37,   153,
     154,   157,    38,   158,   123,   124,   125,   126,    39,   127,
     159,   160,   161,    40,   128,   129,   130,    41,   162,   207,
     163,    42,   164,    58,    59,    60,    61,    62,   165,   167,
     166,    43,    44,   131,   132,   133,   134,   168,     1,   186,
     187,   188,    45,     2,    46,     3,     4,     5,     6,   189,
     135,   194,     7,     8,     9,    10,    11,   195,   196,   136,
     137,   198,    12,    13,    14,    15,    16,    17,   201,   202,
     138,   139,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   203,    31,    32,    33,   205,
      34,    35,   206,   211,   215,   224,    36,    37,   209,   214,
     223,    38,    58,    59,    60,    61,    62,    39,   225,   226,
     227,   228,    40,   231,   232,   233,    41,   234,   235,   236,
      42,    58,    59,    60,    61,    62,   237,   238,   239,   240,
      43,    44,   241,   244,   245,   242,   250,   252,   253,   251,
     254,    45,   256,    46,   255,   257,   259,   260,   258,   262,
     145,   265,   271,   266,   269,   281,   283,   284,   282,     0,
     285,     0,   268
};

static const yytype_int16 yycheck[] =
{
      26,     3,    10,    18,    18,    15,    16,    17,    18,    72,
      20,    21,    22,    23,    24,    25,     3,    61,    62,    45,
      90,    61,    62,    93,    82,    83,    18,    66,    90,    22,
      23,    24,    25,    26,    22,    23,    24,    25,    26,   102,
      13,    90,   104,    53,    22,    23,    24,    25,    26,    93,
      90,    90,    90,    90,   103,    33,   105,   244,    90,    58,
      93,    93,    90,    91,    57,   103,   103,   105,   105,    68,
     103,   258,   105,     4,    90,    90,    90,    93,    86,    87,
      88,    89,    78,    79,    80,    95,    96,    97,     4,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    90,    92,
      98,    90,   100,    90,    92,    73,    74,    75,    76,   107,
      20,    21,    90,    63,    64,    65,    90,   127,   144,   145,
     130,   131,    93,   133,   134,    20,    21,   137,   138,    98,
       4,   100,   103,   143,   105,    98,     0,   100,   107,     3,
      98,    98,   100,   100,     8,    54,    10,    11,    12,    13,
      18,    19,    54,    17,    18,    19,    20,    21,    54,    93,
      93,    69,    69,    27,    28,    29,    30,    31,    32,    68,
      93,   173,   198,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    90,    51,    52,    53,
       0,    55,    56,    93,    21,    93,    21,    61,    62,    20,
      20,    93,    66,    93,     4,     5,     6,     7,    72,     9,
      93,    93,    93,    77,    14,    15,    16,    81,    93,    18,
      93,    85,    93,    22,    23,    24,    25,    26,    93,    90,
      93,    95,    96,    33,    34,    35,    36,    90,     3,    91,
      90,    84,   106,     8,   108,    10,    11,    12,    13,    84,
      50,    90,    17,    18,    19,    20,    21,    93,    90,    59,
      60,   106,    27,    28,    29,    30,    31,    32,    90,    93,
      70,    71,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    90,    51,    52,    53,    93,
      55,    56,    90,    90,    90,   102,    61,    62,    18,    93,
      93,    66,    22,    23,    24,    25,    26,    72,    93,    93,
      93,    93,    77,    93,    93,    93,    81,    93,    93,    93,
      85,    22,    23,    24,    25,    26,    93,    93,    90,    93,
      95,    96,    93,   102,    93,   108,    93,    93,    93,   102,
      93,   106,    93,   108,   104,    93,    93,    90,   102,    90,
     100,    93,   104,    93,    93,    93,    90,    93,   104,    -1,
      93,    -1,   251
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     8,    10,    11,    12,    13,    17,    18,    19,
      20,    21,    27,    28,    29,    30,    31,    32,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    51,    52,    53,    55,    56,    61,    62,    66,    72,
      77,    81,    85,    95,    96,   106,   108,   110,   111,   115,
     116,   118,     3,    90,    61,    62,    93,   116,    22,    23,
      24,    25,    26,    33,    90,   114,    13,    90,    93,    90,
      93,    20,    21,    20,    21,    98,   100,    98,   100,     4,
      90,   114,   114,   114,   114,    90,   114,   114,   114,   114,
     114,   114,   118,     4,     4,    54,    54,    54,    93,    58,
      68,    69,    69,    68,    73,    74,    75,    76,    78,    79,
      80,    82,    83,    10,    86,    87,    88,    89,    93,    93,
     118,    90,     0,     4,     5,     6,     7,     9,    14,    15,
      16,    33,    34,    35,    36,    50,    59,    60,    70,    71,
      63,    64,    65,   117,    98,   100,    93,   114,    93,    90,
      93,    21,    21,    20,    20,    18,    90,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    90,    90,   114,
     114,   114,   114,    57,    92,   114,   114,   114,    92,   114,
     114,   114,   114,   114,    90,    91,    91,    90,    84,    84,
      18,    19,    66,    90,    90,    93,    90,   107,   106,    18,
      90,    90,    93,    90,   114,    93,    90,    18,   114,    18,
     114,    90,   114,   114,    93,    90,   114,   114,    18,    90,
     114,   118,   118,    93,   102,    93,    93,    93,    93,    90,
     116,    93,    93,    93,    93,    93,    93,    93,    93,    90,
      93,    93,   108,   118,   102,    93,    90,   104,    72,   102,
      93,   102,    93,    93,    93,   104,    93,    93,   102,    93,
      90,   112,    90,   107,   112,    93,    93,   113,   113,    93,
     112,   104,    90,   103,   105,   103,    93,   103,   105,   103,
     103,    93,   104,    90,    93,    93
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,   109,   110,   110,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   112,   112,   112,   112,   112,   113,   113,
     113,   114,   114,   114,   114,   114,   114,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   116,   116,   117,   117,   117,   118,   118,   118,
     118,   118,   118,   118
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     2,     2,
       3,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     3,     3,     2,     2,     3,     3,     6,     3,     6,
       3,     3,     4,     4,     4,     2,     4,     4,     4,     3,
       3,     3,     3,     3,     3,     3,     4,     6,     2,     2,
       3,     3,     3,     2,     3,     4,     4,     4,     4,     5,
       4,     4,     3,     4,     4,     4,     4,     4,     4,     3,
       3,     3,     3,     4,     3,     6,     4,     3,     6,     3,
       4,     5,     3,     3,     3,     4,     3,     2,     2,     2,
       2,     4,     4,     1,     3,     2,     3,     4,     1,     2,
       3,     0,     1,     1,     1,     1,     1,     0,     1,     1,
       3,     3,     3,     3,     1,     1,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     3,     5,     5
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* prog: expr  */
#line 162 "grammar.y"
                {   
		StartNode = (yyvsp[0].value); 
	}
#line 1733 "grammar.c"
    break;

  case 4: /* term: ANY  */
#line 167 "grammar.y"
            { /* this is an unconditionally true expression, as a filter applies in any case */
		(yyval.param).self = NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, (void *)-1 ); 
	}
#line 1741 "grammar.c"
    break;

  case 5: /* term: IDENT STRING  */
#line 171 "grammar.y"
                       {	
		if ( !ScreenIdentString((yyvsp[0].s)) ) {
			yyerror("Illegal ident string");
			YYABORT;
		}

		uint32_t	index = AddIdent((yyvsp[0].s));
		(yyval.param).self = NewBlock(0, 0, index, CMP_IDENT, FUNC_NONE, NULL ); 
	}
#line 1755 "grammar.c"
    break;

  case 6: /* term: IPV4  */
#line 181 "grammar.y"
               { 
		(yyval.param).self = NewBlock(OffsetRecordMFlags, (1LL << ShiftRecordMFlags)  & MaskRecordMFlags, 
					(0LL << ShiftRecordMFlags)  & MaskRecordMFlags, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1764 "grammar.c"
    break;

  case 7: /* term: IPV6  */
#line 186 "grammar.y"
               { 
		(yyval.param).self = NewBlock(OffsetRecordMFlags, (1LL << ShiftRecordMFlags)  & MaskRecordMFlags, 
					(1LL << ShiftRecordMFlags)  & MaskRecordMFlags, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1773 "grammar.c"
    break;

  case 8: /* term: PROTO NUMBER  */
#line 191 "grammar.y"
                       { 
		int64_t	proto;
		proto = (yyvsp[0].value);

		if ( proto > 255 ) {
			yyerror("Protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown protocol");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetProto, MaskProto, (proto << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL); 

	}
#line 1793 "grammar.c"
    break;

  case 9: /* term: PROTO STRING  */
#line 207 "grammar.y"
                       { 
		int64_t	proto;
		proto = ProtoNum((yyvsp[0].s));

		if ( proto > 255 ) {
			yyerror("Protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown protocol");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetProto, MaskProto, (proto << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1812 "grammar.c"
    break;

  case 10: /* term: TUN PROTO NUMBER  */
#line 222 "grammar.y"
                           { 
		int64_t	proto;
		proto = (yyvsp[0].value);

		if ( proto > 255 ) {
			yyerror("Tunnel protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown tunnel protocol");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetTUNPROTO, MaskTUNPROTO, (proto << ShiftTUNPROTO)  & MaskTUNPROTO, CMP_EQ, FUNC_NONE, NULL); 

	}
#line 1832 "grammar.c"
    break;

  case 11: /* term: TUN PROTO STRING  */
#line 238 "grammar.y"
                           { 
		int64_t	proto;
		proto = ProtoNum((yyvsp[0].s));

		if ( proto > 255 ) {
			yyerror("Tunnel protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown tunnel protocol");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetTUNPROTO, MaskTUNPROTO, (proto << ShiftTUNPROTO)  & MaskTUNPROTO, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1851 "grammar.c"
    break;

  case 12: /* term: dqual PACKETS comp NUMBER  */
#line 254 "grammar.y"
                                    { 

		switch ( (yyvsp[-3].param).direction ) {
			case DIR_UNSPEC:
			case DIR_IN: 
				(yyval.param).self = NewBlock(OffsetPackets, MaskPackets, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				(yyval.param).self = NewBlock(OffsetOutPackets, MaskPackets, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			default:
				/* should never happen */
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 1873 "grammar.c"
    break;

  case 13: /* term: dqual BYTES comp NUMBER  */
#line 272 "grammar.y"
                                  {	

		switch ( (yyvsp[-3].param).direction ) {
			case DIR_UNSPEC:
			case DIR_IN: 
				(yyval.param).self = NewBlock(OffsetBytes, MaskBytes, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				(yyval.param).self = NewBlock(OffsetOutBytes, MaskBytes, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 1894 "grammar.c"
    break;

  case 14: /* term: FLOWS comp NUMBER  */
#line 289 "grammar.y"
                            {	
			(yyval.param).self = NewBlock(OffsetAggrFlows, MaskFlows, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 1902 "grammar.c"
    break;

  case 15: /* term: PPS comp NUMBER  */
#line 293 "grammar.y"
                          {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_PPS, NULL); 
	}
#line 1910 "grammar.c"
    break;

  case 16: /* term: BPS comp NUMBER  */
#line 297 "grammar.y"
                          {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_BPS, NULL); 
	}
#line 1918 "grammar.c"
    break;

  case 17: /* term: BPP comp NUMBER  */
#line 301 "grammar.y"
                          {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_BPP, NULL); 
	}
#line 1926 "grammar.c"
    break;

  case 18: /* term: DURATION comp NUMBER  */
#line 305 "grammar.y"
                               {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_DURATION, NULL); 
	}
#line 1934 "grammar.c"
    break;

  case 19: /* term: COUNT comp NUMBER  */
#line 309 "grammar.y"
                            {	
		(yyval.param).self = NewBlock(OffsetFlowCount, MaskFlowCount, ((yyvsp[0].value) << ShiftFlowCount) & MaskFlowCount, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 1942 "grammar.c"
    break;

  case 20: /* term: dqual TOS comp NUMBER  */
#line 313 "grammar.y"
                                {	
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("TOS must be 0..255");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case DIR_UNSPEC:
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetTos, MaskTos, ((yyvsp[0].value) << ShiftTos) & MaskTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetDstTos, MaskDstTos, ((yyvsp[0].value) << ShiftDstTos) & MaskDstTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case SOURCE_OR_DESTINATION: 
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetTos, MaskTos, ((yyvsp[0].value) << ShiftTos) & MaskTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL),
					NewBlock(OffsetDstTos, MaskDstTos, ((yyvsp[0].value) << ShiftDstTos) & MaskDstTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetTos, MaskTos, ((yyvsp[0].value) << ShiftTos) & MaskTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL),
					NewBlock(OffsetDstTos, MaskDstTos, ((yyvsp[0].value) << ShiftDstTos) & MaskDstTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
			}
	}
#line 1978 "grammar.c"
    break;

  case 21: /* term: NFVERSION comp NUMBER  */
#line 345 "grammar.y"
                                {	
		if ( (yyvsp[0].value) > 10 ) {
			yyerror("Netflow version must be <= 10");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetRecordVersion, MaskRecordVersion, ((yyvsp[0].value) << ShiftRecordVersion) & MaskRecordVersion, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 1990 "grammar.c"
    break;

  case 22: /* term: FLAGS comp NUMBER  */
#line 353 "grammar.y"
                                {	
		if ( (yyvsp[0].value) > 63 ) {
			yyerror("Flags must be 0..63");
			YYABORT;
		}
		(yyval.param).self = Connect_AND(
			// imply flags with proto TCP
			NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_TCP << ShiftProto) & MaskProto, CMP_EQ, FUNC_NONE, NULL),
			NewBlock(OffsetFlags, MaskFlags, ((yyvsp[0].value) << ShiftFlags) & MaskFlags, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
		);
	}
#line 2006 "grammar.c"
    break;

  case 23: /* term: FLAGS AS  */
#line 365 "grammar.y"
                        {	
		// handle special case with 'AS' takes as flags. and not AS number
		uint64_t fl = 0;
		fl |= 16;
		fl |= 2;
		(yyval.param).self = Connect_AND(
			// imply flags with proto TCP 
			NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_TCP << ShiftProto) & MaskProto, CMP_EQ, FUNC_NONE, NULL),
			NewBlock(OffsetFlags, (fl << ShiftFlags) & MaskFlags, (fl << ShiftFlags) & MaskFlags, CMP_FLAGS, FUNC_NONE, NULL)
		);
	}
#line 2022 "grammar.c"
    break;

  case 24: /* term: FLAGS STRING  */
#line 377 "grammar.y"
                        {	
		uint64_t fl = 0;
		int cnt     = 0;
		size_t		len = strlen((yyvsp[0].s));

		if ( len > 7 ) {
			yyerror("Too many flags");
			YYABORT;
		}

		if ( strchr((yyvsp[0].s), 'F') ) { fl |=  1; cnt++; }
		if ( strchr((yyvsp[0].s), 'S') ) { fl |=  2; cnt++; }
		if ( strchr((yyvsp[0].s), 'R') ) { fl |=  4; cnt++; }
		if ( strchr((yyvsp[0].s), 'P') ) { fl |=  8; cnt++; }
		if ( strchr((yyvsp[0].s), 'A') ) { fl |=  16; cnt++; }
		if ( strchr((yyvsp[0].s), 'U') ) { fl |=  32; cnt++; }
		if ( strchr((yyvsp[0].s), 'X') ) { fl =  63; cnt++; }

		if ( cnt != len ) {
			yyerror("Too many flags");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			// imply flags with proto TCP
			NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_TCP << ShiftProto) & MaskProto, CMP_EQ, FUNC_NONE, NULL),
			NewBlock(OffsetFlags, (fl << ShiftFlags) & MaskFlags, (fl << ShiftFlags) & MaskFlags, CMP_FLAGS, FUNC_NONE, NULL)
		);
	}
#line 2056 "grammar.c"
    break;

  case 25: /* term: dqual IP STRING  */
#line 407 "grammar.y"
                          { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		if ( ret == -2 ) {
			// could not resolv host => 'not any'
			(yyval.param).self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetSrcIPv6a, OffsetSrcIPv6b, OffsetDstIPv6a, OffsetDstIPv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( (yyvsp[-2].param).direction ) {
				case SOURCE:
				case DESTINATION:
					(yyval.param).self = ChainHosts(offsets, IPstack, num_ip, (yyvsp[-2].param).direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} // End of switch

		}
	}
#line 2106 "grammar.c"
    break;

  case 26: /* term: dqual TUNIP STRING  */
#line 453 "grammar.y"
                             { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		if ( ret == -2 ) {
			// could not resolv host => 'not any'
			(yyval.param).self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetTUNSRCIP, OffsetTUNSRCIP+1, OffsetTUNDSTIP, OffsetTUNDSTIP+1 };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( (yyvsp[-2].param).direction ) {
				case SOURCE:
				case DESTINATION:
					(yyval.param).self = ChainHosts(offsets, IPstack, num_ip, (yyvsp[-2].param).direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} // End of switch

		}
	}
#line 2156 "grammar.c"
    break;

  case 27: /* term: dqual IP IN '[' iplist ']'  */
#line 499 "grammar.y"
                                     { 	

		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}
	}
#line 2188 "grammar.c"
    break;

  case 28: /* term: NEXT IP STRING  */
#line 527 "grammar.y"
                         { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			NewBlock(OffsetNexthopv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetNexthopv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2219 "grammar.c"
    break;

  case 29: /* term: NEXT IP IN '[' iplist ']'  */
#line 554 "grammar.y"
                                    { 	

		(yyval.param).self = NewBlock(OffsetNexthopv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );

	}
#line 2229 "grammar.c"
    break;

  case 30: /* term: BGPNEXTHOP IP STRING  */
#line 560 "grammar.y"
                               { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			NewBlock(OffsetBGPNexthopv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetBGPNexthopv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2260 "grammar.c"
    break;

  case 31: /* term: ROUTER IP STRING  */
#line 587 "grammar.y"
                           { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			NewBlock(OffsetRouterv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetRouterv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2291 "grammar.c"
    break;

  case 32: /* term: CLIENT LATENCY comp NUMBER  */
#line 614 "grammar.y"
                                     { 	
		(yyval.param).self = NewBlock(OffsetClientLatency, MaskLatency, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 2299 "grammar.c"
    break;

  case 33: /* term: SERVER LATENCY comp NUMBER  */
#line 618 "grammar.y"
                                     { 	
		(yyval.param).self = NewBlock(OffsetServerLatency, MaskLatency, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 2307 "grammar.c"
    break;

  case 34: /* term: APP LATENCY comp NUMBER  */
#line 622 "grammar.y"
                                  { 	
		(yyval.param).self = NewBlock(OffsetAppLatency, MaskLatency, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 2315 "grammar.c"
    break;

  case 35: /* term: SYSID NUMBER  */
#line 626 "grammar.y"
                       { 	
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Router SysID expected between be 1..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetExporterSysID, MaskExporterSysID, ((yyvsp[0].value) << ShiftExporterSysID) & MaskExporterSysID, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 2327 "grammar.c"
    break;

  case 36: /* term: dqual PORT comp NUMBER  */
#line 634 "grammar.y"
                                 {	
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetPort, MaskSrcPort, ((yyvsp[0].value) << ShiftSrcPort) & MaskSrcPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetPort, MaskDstPort, ((yyvsp[0].value) << ShiftDstPort) & MaskDstPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, ((yyvsp[0].value) << ShiftSrcPort) & MaskSrcPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetPort, MaskDstPort, ((yyvsp[0].value) << ShiftDstPort) & MaskDstPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetPort, MaskSrcPort, ((yyvsp[0].value) << ShiftSrcPort) & MaskSrcPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetPort, MaskDstPort, ((yyvsp[0].value) << ShiftDstPort) & MaskDstPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch

	}
#line 2364 "grammar.c"
    break;

  case 37: /* term: INGRESS VRF comp NUMBER  */
#line 667 "grammar.y"
                          {
		if ( (yyvsp[0].value) > 0xFFFFFFFFLL ) {
			yyerror("Invalid ingress vrf ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetIVRFID, MaskIVRFID, ( (yyvsp[0].value) << ShiftIVRFID) & MaskIVRFID, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
	}
#line 2376 "grammar.c"
    break;

  case 38: /* term: EGRESS VRF comp NUMBER  */
#line 675 "grammar.y"
                                 {
		if ( (yyvsp[0].value) > 0xFFFFFFFFLL ) {
			yyerror("Invalid egress vrf ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetEVRFID, MaskEVRFID, ( (yyvsp[0].value) << ShiftEVRFID) & MaskEVRFID, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
	}
#line 2388 "grammar.c"
    break;

  case 39: /* term: PF PFACTION STRING  */
#line 683 "grammar.y"
                     {
			uint64_t index = pfActionNr((yyvsp[0].s));
			if ( index < 0 ) {
				yyerror("Invalid pf action");
				printf("Possible pf action values: ");
				pfListActions();
			} else {
				(yyval.param).self = NewBlock(OffsetPfInfo, MaskPfAction, ( index << ShiftPfAction) & MaskPfAction, CMP_EQ, FUNC_NONE, NULL );
			}
}
#line 2403 "grammar.c"
    break;

  case 40: /* term: PF PFACTION NAT  */
#line 694 "grammar.y"
                  {
			uint64_t index = pfActionNr("nat");
			if ( index < 0 ) {
				yyerror("Invalid pf action");
				printf("Possible pf action values: ");
				pfListActions();
			} else {
				(yyval.param).self = NewBlock(OffsetPfInfo, MaskPfAction, ( index << ShiftPfAction) & MaskPfAction, CMP_EQ, FUNC_NONE, NULL );
			}
}
#line 2418 "grammar.c"
    break;

  case 41: /* term: PF PFREASON STRING  */
#line 705 "grammar.y"
                     {
			uint64_t index = pfReasonNr((yyvsp[0].s));
			if ( index < 0 ) {
				yyerror("Invalid pf reason");
				printf("Possible pf reason values: ");
				pfListReasons();
			} else {
				(yyval.param).self = NewBlock(OffsetPfInfo, MaskPfReason, ( index << ShiftPfReason) & MaskPfReason, CMP_EQ, FUNC_NONE, NULL );
			}
}
#line 2433 "grammar.c"
    break;

  case 42: /* term: PF INTERFACE STRING  */
#line 716 "grammar.y"
                      {
	union {
		char ifName[16];
		uint64_t val[2];
	} ifValue = {0};
	size_t len = strlen((yyvsp[0].s));
	if ( len > 15 ) {
				yyerror("Invalid pf interface name length");
	}
	memcpy(ifValue.ifName, (yyvsp[0].s), len);
	(yyval.param).self = Connect_AND(
					NewBlock(OffsetPfIfname, MaskPfIfname, ifValue.val[0], CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetPfIfname+1, MaskPfIfname, ifValue.val[1], CMP_EQ, FUNC_NONE, NULL )
				);
}
#line 2453 "grammar.c"
    break;

  case 43: /* term: PF RULE NUMBER  */
#line 732 "grammar.y"
                 {
	(yyval.param).self = NewBlock(OffsetPfInfo, MaskPfRulenr, ( (yyvsp[0].value) << ShiftPfRulenr) & MaskPfRulenr, CMP_EQ, FUNC_NONE, NULL );
}
#line 2461 "grammar.c"
    break;

  case 44: /* term: PF DIR IN  */
#line 736 "grammar.y"
            {
	(yyval.param).self = NewBlock(OffsetPfInfo, MaskPfDir, ( 1LL << ShiftPfDir) & MaskPfDir, CMP_EQ, FUNC_NONE, NULL );
}
#line 2469 "grammar.c"
    break;

  case 45: /* term: PF DIR OUT  */
#line 740 "grammar.y"
             {
	(yyval.param).self = NewBlock(OffsetPfInfo, MaskPfDir, ( 0LL << ShiftPfDir) & MaskPfDir, CMP_EQ, FUNC_NONE, NULL );
}
#line 2477 "grammar.c"
    break;

  case 46: /* term: dqual PORT IN PBLOCK  */
#line 744 "grammar.y"
                               {	
#ifdef NSEL
		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
					(yyval.param).self = NewBlock(OffsetPort, MaskSrcPort, ShiftSrcPort, CMP_EQ, FUNC_PBLOCK, NULL );
				break;
			case DESTINATION:
					(yyval.param).self = NewBlock(OffsetPort, MaskDstPort, ShiftDstPort, CMP_EQ, FUNC_PBLOCK, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, ShiftSrcPort, CMP_EQ, FUNC_PBLOCK, NULL ),
					NewBlock(OffsetPort, MaskDstPort, ShiftDstPort, CMP_EQ, FUNC_PBLOCK, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch

#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2508 "grammar.c"
    break;

  case 47: /* term: dqual PORT IN '[' ullist ']'  */
#line 771 "grammar.y"
                                       { 	
		struct ULongListNode *node;
		ULongtree_t *root = NULL;

		if ( (yyvsp[-5].param).direction == DIR_UNSPEC || (yyvsp[-5].param).direction == SOURCE_OR_DESTINATION || (yyvsp[-5].param).direction == SOURCE_AND_DESTINATION ) {
			// src and/or dst port
			// we need a second rbtree due to different shifts for src and dst ports
			root = malloc(sizeof(ULongtree_t));

			struct ULongListNode *n;
			if ( root == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			RB_INIT(root);

			RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
				if ( node->value > 65535 ) {
					yyerror("Port outside of range 0..65535");
					YYABORT;
				}
				if ((n = malloc(sizeof(struct ULongListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				n->value 	= (node->value << ShiftDstPort) & MaskDstPort;
				node->value = (node->value << ShiftSrcPort) & MaskSrcPort;
				RB_INSERT(ULongtree, root, n);
			}
		}

		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftSrcPort) & MaskSrcPort;
				}
				(yyval.param).self = NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftDstPort) & MaskDstPort;
				}
				(yyval.param).self = NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch
	}
#line 2575 "grammar.c"
    break;

  case 48: /* term: ICMP_TYPE NUMBER  */
#line 834 "grammar.y"
                           {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("ICMP type of range 0..255");
			YYABORT;
		}
		(yyval.param).self = Connect_AND(
			// imply ICMP-TYPE with a proto ICMP block
			Connect_OR (
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMP << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL), 
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMPV6 << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL)
			),
			NewBlock(OffsetICMP, MaskICMPtype, ((yyvsp[0].value) << ShiftICMPtype) & MaskICMPtype, CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2594 "grammar.c"
    break;

  case 49: /* term: ICMP_CODE NUMBER  */
#line 849 "grammar.y"
                           {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("ICMP code of range 0..255");
			YYABORT;
		}
		(yyval.param).self = Connect_AND(
			// imply ICMP-CODE with a proto ICMP block
			Connect_OR (
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMP << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL), 
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMPV6 << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL)
			),
			NewBlock(OffsetICMP, MaskICMPcode, ((yyvsp[0].value) << ShiftICMPcode) & MaskICMPcode, CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2613 "grammar.c"
    break;

  case 50: /* term: ENGINE_TYPE comp NUMBER  */
#line 864 "grammar.y"
                                  {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Engine type of range 0..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetRouterID, MaskEngineType, ((yyvsp[0].value) << ShiftEngineType) & MaskEngineType, (yyvsp[-1].param).comp, FUNC_NONE, NULL);
	}
#line 2625 "grammar.c"
    break;

  case 51: /* term: ENGINE_ID comp NUMBER  */
#line 872 "grammar.y"
                                {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Engine ID of range 0..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetRouterID, MaskEngineID, ((yyvsp[0].value) << ShiftEngineID) & MaskEngineID, (yyvsp[-1].param).comp, FUNC_NONE, NULL);
	}
#line 2637 "grammar.c"
    break;

  case 52: /* term: EXPORTER comp NUMBER  */
#line 880 "grammar.y"
                               {
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Exporter ID of range 0..65535");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetExporterSysID, MaskExporterSysID, ((yyvsp[0].value) << ShiftExporterSysID) & MaskExporterSysID, (yyvsp[-1].param).comp, FUNC_NONE, NULL);
	}
#line 2649 "grammar.c"
    break;

  case 53: /* term: LABEL STRING  */
#line 889 "grammar.y"
               {	
		if ( strlen((yyvsp[0].s)) > 16 ) {
			yyerror("Size flowlabel of range 1..16");
			YYABORT;
		}

		(yyval.param).self = NewBlock(0, 0, 0, CMP_FLOWLABEL, FUNC_NONE, (void *)strdup((yyvsp[0].s))); 
	}
#line 2662 "grammar.c"
    break;

  case 54: /* term: ASA EVENT REASON  */
#line 898 "grammar.y"
                           {
#ifdef NSEL
		if ( strncasecmp((yyvsp[0].s),"ignore", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_IGNORE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"create", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_CREATE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"term", 4) == 0 || strncasecmp((yyvsp[0].s),"delete", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DELETE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp((yyvsp[0].s),"deny", 4) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp((yyvsp[0].s),"alert", 5) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_ALERT << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp((yyvsp[0].s),"update", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_UPDATE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else {
			yyerror("Unknown asa event");
			YYABORT;
		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2690 "grammar.c"
    break;

  case 55: /* term: ASA EVENT comp NUMBER  */
#line 922 "grammar.y"
                                {
#ifdef NSEL
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Invalid xevent ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( (yyvsp[0].value) << ShiftFWevent) & MaskFWevent, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2707 "grammar.c"
    break;

  case 56: /* term: ASA EVENT DENIED inout  */
#line 935 "grammar.y"
                                 {
#ifdef NSEL
		uint64_t xevent = 0;
		if ( (yyvsp[0].param).inout == INGRESS ) {
			xevent = 1001;
		} else if ( (yyvsp[0].param).inout == EGRESS ) {
			xevent = 1002;
		} else {
				yyerror("Invalid inout token");
				YYABORT;
		}
		(yyval.param).self = Connect_AND(
			NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetConnID, MaskFWXevent, ( xevent << ShiftFWXevent) & MaskFWXevent, CMP_EQ, FUNC_NONE, NULL )
		);
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2732 "grammar.c"
    break;

  case 57: /* term: ASA EVENT DENIED STRING  */
#line 955 "grammar.y"
                                  {
#ifdef NSEL
		uint64_t xevent = 0;
		if( strncasecmp((yyvsp[0].s),"interface", 9) == 0) {
			xevent = 1003;
		} else if( strncasecmp((yyvsp[0].s),"nosyn", 5) == 0) {
			xevent = 1004;
		} else {
			xevent = (uint64_t)strtol((yyvsp[0].s), (char **)NULL, 10);
			if ( (xevent == 0 && errno == EINVAL) || xevent > 65535 ) {
				yyerror("Invalid xevent ID");
				YYABORT;
			}
		}
		(yyval.param).self = Connect_AND(
			NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetConnID, MaskFWXevent, ( xevent << ShiftFWXevent) & MaskFWXevent, CMP_EQ, FUNC_NONE, NULL )
		);
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2760 "grammar.c"
    break;

  case 58: /* term: ASA XEVENT comp NUMBER  */
#line 979 "grammar.y"
                                 {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Invalid xevent ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetConnID, MaskFWXevent, ( (yyvsp[0].value) << ShiftFWXevent) & MaskFWXevent, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2777 "grammar.c"
    break;

  case 59: /* term: dqual XNET STRING '/' NUMBER  */
#line 992 "grammar.y"
                                       { 
#ifdef NSEL
		int af, bytes, ret;
		uint64_t	mask[2];

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set


		if ( (yyvsp[0].value) > (bytes*8) ) {
			yyerror("Too many netbits for this IP address");
			YYABORT;
		}

		if ( af == PF_INET ) {
			mask[0] = 0xffffffffffffffffLL;
			mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
		} else {	// PF_INET6
			if ( (yyvsp[0].value) > 64 ) {
				mask[0] = 0xffffffffffffffffLL;
				mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
			} else {
				mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
				mask[1] = 0;
			}
		}
		// IP aadresses are stored in network representation 
		mask[0]	 = mask[0];
		mask[1]	 = mask[1];

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( (yyvsp[-4].param).direction ) {
			case SOURCE:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2871 "grammar.c"
    break;

  case 60: /* term: dqual XPORT comp NUMBER  */
#line 1082 "grammar.y"
                                  {	
#ifdef NSEL
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif

	}
#line 2913 "grammar.c"
    break;

  case 61: /* term: inout acl comp NUMBER  */
#line 1120 "grammar.y"
                                {
#ifdef NSEL
		uint64_t offset, mask, shift;
		if ( (yyvsp[-3].param).inout == INGRESS ) {
			switch ((yyvsp[-2].param).acl) {
				case ACL:
					offset = OffsetIngressAclId;
					mask   = MaskIngressAclId;	
					shift  = ShiftIngressAclId;
					break;
				case ACE:
					offset = OffsetIngressAceId;
					mask   = MaskIngressAceId;	
					shift  = ShiftIngressAceId;
					break;
				case XACE:
					offset = OffsetIngressGrpId;
					mask   = MaskIngressGrpId;	
					shift  = ShiftIngressGrpId;
					break;
				default:
					yyerror("Invalid ACL specifier");
					YYABORT;
			}
		} else if ( (yyvsp[-3].param).inout == EGRESS && (yyval.param).acl == ACL ) {
			offset = OffsetEgressAclId;
			mask   = MaskEgressAclId;	
			shift  = ShiftEgressAclId;
		} else {
			yyerror("ingress/egress syntax error");
			YYABORT;
		}
		(yyval.param).self = NewBlock(offset, mask, ((yyvsp[0].value) << shift) & mask , (yyvsp[-1].param).comp, FUNC_NONE, NULL );

#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2957 "grammar.c"
    break;

  case 62: /* term: NAT EVENT REASON  */
#line 1160 "grammar.y"
                           {
#ifdef NSEL
		if ( strncasecmp((yyvsp[0].s),"invalid", 7) == 0) {
			(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( NEL_EVENT_INVALID << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"add", 3) == 0 || strncasecmp((yyvsp[0].s),"create", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( NEL_EVENT_ADD << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"delete", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( NEL_EVENT_DELETE << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else {
			yyerror("Unknown nat event");
			YYABORT;
		}
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2979 "grammar.c"
    break;

  case 63: /* term: NAT EVENT comp NUMBER  */
#line 1178 "grammar.y"
                                {
#ifdef NSEL
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Invalid event ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( (yyvsp[0].value) << ShiftNATevent) & MasNATevent, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2996 "grammar.c"
    break;

  case 64: /* term: PBLOCK START comp NUMBER  */
#line 1193 "grammar.y"
                                   {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockStart, ( (yyvsp[0].value) << ShiftPortBlockStart) & MaskPortBlockStart, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 3013 "grammar.c"
    break;

  case 65: /* term: PBLOCK END comp NUMBER  */
#line 1206 "grammar.y"
                                 {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockEnd, ( (yyvsp[0].value) << ShiftPortBlockEnd) & MaskPortBlockEnd, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 3030 "grammar.c"
    break;

  case 66: /* term: PBLOCK STEP comp NUMBER  */
#line 1219 "grammar.y"
                                  {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockStep, ( (yyvsp[0].value) << ShiftPortBlockStep) & MaskPortBlockStep, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 3047 "grammar.c"
    break;

  case 67: /* term: PBLOCK SIZE comp NUMBER  */
#line 1232 "grammar.y"
                                  {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockSize, ( (yyvsp[0].value) << ShiftPortBlockSize) & MaskPortBlockSize, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 3064 "grammar.c"
    break;

  case 68: /* term: dqual NPORT comp NUMBER  */
#line 1245 "grammar.y"
                                  {	
#ifdef NSEL
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch
#else
		yyerror("NEL/NAT filters not available");
		YYABORT;
#endif

	}
#line 3106 "grammar.c"
    break;

  case 69: /* term: dqual NIP STRING  */
#line 1283 "grammar.y"
                           { 	
#ifdef NSEL
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		if ( ret == -2 ) {
			// could not resolv host => 'not any'
			(yyval.param).self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetXLATESRCv6a, OffsetXLATESRCv6b, OffsetXLATEDSTv6a, OffsetXLATEDSTv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( (yyvsp[-2].param).direction ) {
				case SOURCE:
				case DESTINATION:
					(yyval.param).self = ChainHosts(offsets, IPstack, num_ip, (yyvsp[-2].param).direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} // End of switch

		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 3161 "grammar.c"
    break;

  case 70: /* term: PAYLOAD CONTENT STRING  */
#line 1335 "grammar.y"
                                 {
		if (strlen((yyvsp[0].s))>64) {
			yyerror("word too long");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPayload, 0, 0, CMP_PAYLOAD, FUNC_NONE, (yyvsp[0].s)); 
	}
#line 3173 "grammar.c"
    break;

  case 71: /* term: PAYLOAD CONTENT WORD  */
#line 1343 "grammar.y"
                               {
		if (strlen((yyvsp[0].s))>64) {
			yyerror("word too long");
			YYABORT;
		}
		char *word = stripWord((yyvsp[0].s));
		(yyval.param).self = NewBlock(OffsetPayload, 0, 0, CMP_PAYLOAD, FUNC_NONE, word); 
	}
#line 3186 "grammar.c"
    break;

  case 72: /* term: PAYLOAD REGEX WORD  */
#line 1352 "grammar.y"
                     {
		if (strlen((yyvsp[0].s))>64) {
			yyerror("word too long");
			YYABORT;
		}
		// strip ' or " 
		char *word = stripWord((yyvsp[0].s));

		int err[2];
		srx_Context *program = srx_CreateExt(word, strlen(word), "", err, NULL, NULL);
		if ( !program ) {
			yyerror("failed to compile regex");
		}

		(yyval.param).self = NewBlock(OffsetPayload, 0, 0, CMP_REGEX, FUNC_NONE, (char *)program); 
	}
#line 3207 "grammar.c"
    break;

  case 73: /* term: PAYLOAD REGEX WORD STRING  */
#line 1369 "grammar.y"
                           {
		if (strlen((yyvsp[-1].s))>64) {
			yyerror("word too long");
			YYABORT;
		}
		// strip ' or " 
		char *word = stripWord((yyvsp[-1].s));

		int err[2];
		srx_Context *program = srx_CreateExt(word, strlen(word), (yyvsp[0].s), err, NULL, NULL);
		if ( !program ) {
			yyerror("failed to compile regex");
		}

		(yyval.param).self = NewBlock(OffsetPayload, 0, 0, CMP_REGEX, FUNC_NONE, (char *)program); 
	}
#line 3228 "grammar.c"
    break;

  case 74: /* term: PAYLOAD JA3 STRING  */
#line 1386 "grammar.y"
                             {
		union {
			uint8_t u8[16];
			uint64_t u64[2];
		} ja3;

		if ( strcasecmp((yyvsp[0].s), "defined") == 0) {
			ja3.u64[0] = 0;
			ja3.u64[1] = 0;
			(yyval.param).self = Invert(Connect_AND(
				NewBlock(OffsetJA3, MaskJA3, ja3.u64[0], CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(OffsetJA3+1, MaskJA3, ja3.u64[1], CMP_EQ, FUNC_NONE, NULL )
			));
		} else {
			if (!IsMD5((yyvsp[0].s))) {
				yyerror("not a ja3 hash");
				YYABORT;
			}

			char *pos = (yyvsp[0].s);
			for(int count = 0; count < 16; count++) {
				sscanf(pos, "%2hhx", &ja3.u8[count]);
				pos += 2;
			}
			(yyval.param).self = Connect_AND(
				NewBlock(OffsetJA3, MaskJA3, ja3.u64[0], CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(OffsetJA3+1, MaskJA3, ja3.u64[1], CMP_EQ, FUNC_NONE, NULL )
			);
		}
		ja3Filter = 1;
	}
#line 3264 "grammar.c"
    break;

  case 75: /* term: dqual NIP IN '[' iplist ']'  */
#line 1418 "grammar.y"
                                      { 	
#ifdef NSEL
		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetXLATESRCv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetXLATEDSTv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetXLATESRCv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetXLATEDSTv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATESRCv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetXLATEDSTv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 3300 "grammar.c"
    break;

  case 76: /* term: dqual AS comp NUMBER  */
#line 1450 "grammar.y"
                               {	
		if ( (yyvsp[0].value) > 0xfFFFFFFF ) {
			yyerror("AS number of range");
			YYABORT;
		}

		geoFilter = 1;
		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetAS, MaskSrcAS, ((yyvsp[0].value) << ShiftSrcAS) & MaskSrcAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetAS, MaskDstAS, ((yyvsp[0].value) << ShiftDstAS) & MaskDstAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetAS, MaskSrcAS, ((yyvsp[0].value) << ShiftSrcAS) & MaskSrcAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetAS, MaskDstAS, ((yyvsp[0].value) << ShiftDstAS) & MaskDstAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetAS, MaskSrcAS, ((yyvsp[0].value) << ShiftSrcAS) & MaskSrcAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetAS, MaskDstAS, ((yyvsp[0].value) << ShiftDstAS) & MaskDstAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			case ADJ_PREV:
				(yyval.param).self = NewBlock(OffsetBGPadj, MaskBGPadjPrev, ((yyvsp[0].value) << ShiftBGPadjPrev) & MaskBGPadjPrev, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case ADJ_NEXT:
				(yyval.param).self = NewBlock(OffsetBGPadj, MaskBGPadjNext, ((yyvsp[0].value) << ShiftBGPadjNext) & MaskBGPadjNext, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3344 "grammar.c"
    break;

  case 77: /* term: dqual GEO STRING  */
#line 1490 "grammar.y"
                           {	
		if ( strlen((yyvsp[0].s)) != 2 ) {
			yyerror("Need a two letter geo country code");
			YYABORT;
		}

		geoFilter = 2;
		union {
			char c[8];
			uint64_t u;
		} v;
		v.u = 0;
#ifdef WORDS_BIGENDIAN
                v.c[4] = toupper((yyvsp[0].s)[0]);
                v.c[5] = toupper((yyvsp[0].s)[1]);
#else
                v.c[0] = toupper((yyvsp[0].s)[0]);
                v.c[1] = toupper((yyvsp[0].s)[1]);
#endif
		switch ( (yyvsp[-2].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetGeo, MaskSrcGeo, (v.u << ShiftSrcGeo) & MaskSrcGeo, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetGeo, MaskDstGeo, (v.u << ShiftDstGeo) & MaskDstGeo, CMP_EQ, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetGeo, MaskSrcGeo, (v.u << ShiftSrcGeo) & MaskSrcGeo, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetGeo, MaskDstGeo, (v.u << ShiftDstGeo) & MaskDstGeo, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetGeo, MaskSrcGeo, (v.u << ShiftSrcGeo) & MaskSrcGeo, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetGeo, MaskDstGeo, (v.u << ShiftDstGeo) & MaskDstGeo, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3394 "grammar.c"
    break;

  case 78: /* term: dqual AS IN '[' ullist ']'  */
#line 1536 "grammar.y"
                                     { 	
		struct ULongListNode *node;
		ULongtree_t *root = NULL;

		geoFilter = 1;
		if ( (yyvsp[-5].param).direction == DIR_UNSPEC || (yyvsp[-5].param).direction == SOURCE_OR_DESTINATION || (yyvsp[-5].param).direction == SOURCE_AND_DESTINATION ) {
			// src and/or dst AS
			// we need a second rbtree due to different shifts for src and dst AS
			root = malloc(sizeof(ULongtree_t));

			struct ULongListNode *n;
			if ( root == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			RB_INIT(root);

			RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
				if ( node->value > 0xFFFFFFFFLL ) {
					yyerror("AS number of range");
					YYABORT;
				}
				if ((n = malloc(sizeof(struct ULongListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				n->value 	= (node->value << ShiftDstAS) & MaskDstAS;
				node->value = (node->value << ShiftSrcAS) & MaskSrcAS;
				RB_INSERT(ULongtree, root, n);
			}
		}

		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftSrcAS) & MaskSrcAS;
				}
				(yyval.param).self = NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftDstAS) & MaskDstAS;
				}
				(yyval.param).self = NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}

	}
#line 3463 "grammar.c"
    break;

  case 79: /* term: dqual MASK NUMBER  */
#line 1601 "grammar.y"
                            {	
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Mask outside of range 0..255");
			YYABORT;
		}

		switch ( (yyvsp[-2].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetMask, MaskSrcMask, ((yyvsp[0].value) << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetMask, MaskDstMask, ((yyvsp[0].value) << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetMask, MaskSrcMask, ((yyvsp[0].value) << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetMask, MaskDstMask, ((yyvsp[0].value) << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetMask, MaskSrcMask, ((yyvsp[0].value) << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetMask, MaskDstMask, ((yyvsp[0].value) << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch

	}
#line 3500 "grammar.c"
    break;

  case 80: /* term: dqual NET STRING STRING  */
#line 1634 "grammar.y"
                                  { 
		int af, bytes, ret;
		uint64_t	mask[2];
		ret = parse_ip(&af, (yyvsp[-1].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af != PF_INET ) {
			yyerror("IP netmask syntax valid only for IPv4");
			YYABORT;
		}
		if ( bytes != 4 ) {
			yyerror("Need complete IP address");
			YYABORT;
		}

		ret = parse_ip(&af, (yyvsp[0].s), mask, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af != PF_INET || bytes != 4 ) {
			yyerror("Invalid netmask for IPv4 address");
			YYABORT;
		}

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);		
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				/* should never happen */
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3594 "grammar.c"
    break;

  case 81: /* term: dqual NET STRING '/' NUMBER  */
#line 1724 "grammar.y"
                                      { 
		int af, bytes, ret;
		uint64_t	mask[2];

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set


		if ( (yyvsp[0].value) > (bytes*8) ) {
			yyerror("Too many netbits for this IP address");
			YYABORT;
		}

		if ( af == PF_INET ) {
			mask[0] = 0xffffffffffffffffLL;
			mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
		} else {	// PF_INET6
			if ( (yyvsp[0].value) > 64 ) {
				mask[0] = 0xffffffffffffffffLL;
				mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
			} else {
				mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
				mask[1] = 0;
			}
		}
		// IP aadresses are stored in network representation 
		mask[0]	 = mask[0];
		mask[1]	 = mask[1];

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( (yyvsp[-4].param).direction ) {
			case SOURCE:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3683 "grammar.c"
    break;

  case 82: /* term: dqual IF NUMBER  */
#line 1809 "grammar.y"
                          {
		if ( (yyvsp[0].value) > 0xffffffffLL ) {
			yyerror("Input interface number must 0..2^32");
			YYABORT;
		}

		switch ( (yyvsp[-2].param).direction ) {
			case DIR_UNSPEC:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetInOut, MaskInput, ((yyvsp[0].value) << ShiftInput) & MaskInput, CMP_EQ, FUNC_NONE, NULL),
					NewBlock(OffsetInOut, MaskOutput, ((yyvsp[0].value) << ShiftOutput) & MaskOutput, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case DIR_IN: 
				(yyval.param).self = NewBlock(OffsetInOut, MaskInput, ((yyvsp[0].value) << ShiftInput) & MaskInput, CMP_EQ, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				(yyval.param).self = NewBlock(OffsetInOut, MaskOutput, ((yyvsp[0].value) << ShiftOutput) & MaskOutput, CMP_EQ, FUNC_NONE, NULL); 
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3713 "grammar.c"
    break;

  case 83: /* term: dqual VLAN NUMBER  */
#line 1835 "grammar.y"
                            {	
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("VLAN number of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-2].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetVlan, MaskSrcVlan, ((yyvsp[0].value) << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetVlan, MaskDstVlan, ((yyvsp[0].value) << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetVlan, MaskSrcVlan, ((yyvsp[0].value) << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetVlan, MaskDstVlan, ((yyvsp[0].value) << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetVlan, MaskSrcVlan, ((yyvsp[0].value) << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetVlan, MaskDstVlan, ((yyvsp[0].value) << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3750 "grammar.c"
    break;

  case 84: /* term: dqual MAC STRING  */
#line 1868 "grammar.y"
                           {
		uint64_t	mac = VerifyMac((yyvsp[0].s));
		if ( mac == 0 ) {
			yyerror("Invalid MAC address format");
			YYABORT;
		}
		switch ( (yyvsp[-2].param).direction ) {
			case DIR_UNSPEC: {
					uint32_t in, out;
					in  = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					out  = Connect_OR(
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					(yyval.param).self = Connect_OR(in, out);
					} break;
			case DIR_IN:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case DIR_OUT:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case SOURCE:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case DESTINATION:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case IN_SRC: 
					(yyval.param).self = NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case IN_DST: 
					(yyval.param).self = NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case OUT_SRC: 
					(yyval.param).self = NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case OUT_DST:
					(yyval.param).self = NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch
	}
#line 3816 "grammar.c"
    break;

  case 85: /* term: MPLS STRING comp NUMBER  */
#line 1930 "grammar.y"
                                  {	
		if ( (yyvsp[0].value) > MPLSMAX ) {
			yyerror("MPLS value out of range");
			YYABORT;
		}

		// search for label1 - label10
		if ( strncasecmp((yyvsp[-2].s), "label", 5) == 0 ) {
			uint64_t mask;
			uint32_t offset, shift;
			char *s = &(yyvsp[-2].s)[5];
			if ( *s == '\0' ) {
				yyerror("Missing label number");
				YYABORT;
			}
			int i = (int)strtol(s, (char **)NULL, 10);

			switch (i) {
				case 1:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 2:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 3:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 4:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 5:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 6:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 7:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 8:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 9:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 10:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				default: 
					yyerror("MPLS label out of range 1..10");
					YYABORT;
			}
			(yyval.param).self = NewBlock(offset, mask, ((yyvsp[0].value) << shift) & mask, (yyvsp[-1].param).comp, FUNC_NONE, NULL );

		} else if ( strcasecmp((yyvsp[-2].s), "eos") == 0 ) {
			// match End of Stack label 
			(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value) << 4, (yyvsp[-1].param).comp, FUNC_MPLS_EOS, NULL );

		} else if ( strncasecmp((yyvsp[-2].s), "exp", 3) == 0 ) {
			uint64_t mask;
			uint32_t offset, shift;
			char *s = &(yyvsp[-2].s)[3];
			if ( *s == '\0' ) {
				yyerror("Missing label number");
				YYABORT;
			}
			int i = (int)strtol(s, (char **)NULL, 10);

			if ( (yyvsp[0].value) > 7 ) {
				yyerror("MPLS exp value out of range");
				YYABORT;
			}

			switch (i) {
				case 1:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 2:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 3:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 4:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 5:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 6:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 7:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 8:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 9:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 10:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				default: 
					yyerror("MPLS label out of range 1..10");
					YYABORT;
			}
			(yyval.param).self = NewBlock(offset, mask, (yyvsp[0].value) << shift, (yyvsp[-1].param).comp, FUNC_NONE, NULL );

		} else {
			yyerror("Unknown MPLS option");
			YYABORT;
		}
	}
#line 3976 "grammar.c"
    break;

  case 86: /* term: MPLS ANY NUMBER  */
#line 2085 "grammar.y"
                          {	
		uint32_t *opt = malloc(sizeof(uint32_t));
		if ( (yyvsp[0].value) > MPLSMAX ) {
			yyerror("MPLS value out of range");
			YYABORT;
		}
		if ( opt == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		*opt = (yyvsp[0].value) << 4;
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value) << 4, CMP_EQ, FUNC_MPLS_ANY, opt );

	}
#line 3995 "grammar.c"
    break;

  case 87: /* term: FWDSTAT NUMBER  */
#line 2099 "grammar.y"
                         {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Forwarding status of range 0..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetStatus, MaskStatus, ((yyvsp[0].value) << ShiftStatus) & MaskStatus, CMP_EQ, FUNC_NONE, NULL);
	}
#line 4007 "grammar.c"
    break;

  case 88: /* term: FWDSTAT STRING  */
#line 2107 "grammar.y"
                         {
		uint64_t id = Get_fwd_status_id((yyvsp[0].s));
		if (id == 256 ) {
			yyerror("Unknown forwarding status");
			YYABORT;
		}

		(yyval.param).self = NewBlock(OffsetStatus, MaskStatus, (id << ShiftStatus) & MaskStatus, CMP_EQ, FUNC_NONE, NULL);

	}
#line 4022 "grammar.c"
    break;

  case 89: /* term: DIR NUMBER  */
#line 2118 "grammar.y"
                     {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Flow direction status > 255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetDir, MaskDir, ((yyvsp[0].value) << ShiftDir) & MaskDir, CMP_EQ, FUNC_NONE, NULL);

	}
#line 4035 "grammar.c"
    break;

  case 90: /* term: DIR inout  */
#line 2127 "grammar.y"
                    {
		uint64_t dir = 0xFF;
		if ( (yyvsp[0].param).inout == INGRESS )
			dir = 0;
		else if ( (yyvsp[0].param).inout == EGRESS )
			dir = 1;
		else {
			yyerror("Flow direction status of range ingress, egress");
			YYABORT;
		}

		(yyval.param).self = NewBlock(OffsetDir, MaskDir, (dir << ShiftDir) & MaskDir, CMP_EQ, FUNC_NONE, NULL);

	}
#line 4054 "grammar.c"
    break;

  case 91: /* term: OBSERVATION DOMAIN ID NUMBER  */
#line 2142 "grammar.y"
                                       {
		(yyval.param).self = NewBlock(OffsetObservationDomainID, MaskObservationDomainID, ((yyvsp[0].value) << ShiftObservationDomainID) & MaskObservationDomainID, CMP_EQ, FUNC_NONE, NULL);
	}
#line 4062 "grammar.c"
    break;

  case 92: /* term: OBSERVATION POINT ID NUMBER  */
#line 2146 "grammar.y"
                                      {
		(yyval.param).self = NewBlock(OffsetObservationPointID, MaskObservationPointID, ((yyvsp[0].value) << ShiftObservationPointID) & MaskObservationPointID, CMP_EQ, FUNC_NONE, NULL);
	}
#line 4070 "grammar.c"
    break;

  case 93: /* iplist: STRING  */
#line 2151 "grammar.y"
                { 
		int i, af, bytes, ret;
		struct IPListNode *node;

		IPlist_t *root = malloc(sizeof(IPlist_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		
		if ( ret != -2 ) {
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
				RB_INSERT(IPtree, root, node);
			}

		}
		(yyval.list) = (void *)root;

	}
#line 4117 "grammar.c"
    break;

  case 94: /* iplist: STRING '/' NUMBER  */
#line 2194 "grammar.y"
                                { 
		int af, bytes, ret;
		struct IPListNode *node;

		IPlist_t *root = malloc(sizeof(IPlist_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		
		if ( ret != -2 ) {
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}

			if ( af == PF_INET ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
			} else {	// PF_INET6
				if ( (yyvsp[0].value) > 64 ) {
					node->mask[0] = 0xffffffffffffffffLL;
					node->mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
				} else {
					node->mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
					node->mask[1] = 0;
				}
			}

			node->ip[0] = IPstack[0] & node->mask[0];
			node->ip[1] = IPstack[1] & node->mask[1];

			RB_INSERT(IPtree, root, node);

		}
		(yyval.list) = (void *)root;

	}
#line 4175 "grammar.c"
    break;

  case 95: /* iplist: iplist STRING  */
#line 2248 "grammar.y"
                        { 
		int i, af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		// ret == - 2 means lookup failure
		if ( ret != -2 ) {
			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
	
				RB_INSERT(IPtree, (IPlist_t *)(yyval.list), node);
			}
		}
	}
#line 4211 "grammar.c"
    break;

  case 96: /* iplist: iplist ',' STRING  */
#line 2279 "grammar.y"
                            { 
		int i, af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		// ret == - 2 means lookup failure
		if ( ret != -2 ) {
			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
	
				RB_INSERT(IPtree, (IPlist_t *)(yyval.list), node);
			}
		}
	}
#line 4247 "grammar.c"
    break;

  case 97: /* iplist: iplist STRING '/' NUMBER  */
#line 2311 "grammar.y"
                                    { 
		int af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		// ret == - 2 means lookup failure
		if ( ret != -2 ) {
			if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			if ( af == PF_INET ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
			} else {	// PF_INET6
				if ( (yyvsp[0].value) > 64 ) {
					node->mask[0] = 0xffffffffffffffffLL;
					node->mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
				} else {
					node->mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
					node->mask[1] = 0;
				}
			}

			node->ip[0] = IPstack[0] & node->mask[0];
			node->ip[1] = IPstack[1] & node->mask[1];

			RB_INSERT(IPtree, (IPlist_t *)(yyval.list), node);
		}
	}
#line 4292 "grammar.c"
    break;

  case 98: /* ullist: NUMBER  */
#line 2355 "grammar.y"
                { 
		struct ULongListNode *node;

		ULongtree_t *root = malloc(sizeof(ULongtree_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = (yyvsp[0].value);

		RB_INSERT(ULongtree, root, node);
		(yyval.list) = (void *)root;
	}
#line 4317 "grammar.c"
    break;

  case 99: /* ullist: ullist NUMBER  */
#line 2376 "grammar.y"
                        { 
		struct ULongListNode *node;

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = (yyvsp[0].value);
		RB_INSERT(ULongtree, (ULongtree_t *)(yyval.list), node);
	}
#line 4332 "grammar.c"
    break;

  case 100: /* ullist: ullist ',' NUMBER  */
#line 2387 "grammar.y"
                            { 
		struct ULongListNode *node;

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = (yyvsp[0].value);
		RB_INSERT(ULongtree, (ULongtree_t *)(yyval.list), node);
	}
#line 4347 "grammar.c"
    break;

  case 101: /* comp: %empty  */
#line 2401 "grammar.y"
                                { (yyval.param).comp = CMP_EQ; }
#line 4353 "grammar.c"
    break;

  case 102: /* comp: EQ  */
#line 2402 "grammar.y"
                                { (yyval.param).comp = CMP_EQ; }
#line 4359 "grammar.c"
    break;

  case 103: /* comp: LT  */
#line 2403 "grammar.y"
                                { (yyval.param).comp = CMP_LT; }
#line 4365 "grammar.c"
    break;

  case 104: /* comp: GT  */
#line 2404 "grammar.y"
                                { (yyval.param).comp = CMP_GT; }
#line 4371 "grammar.c"
    break;

  case 105: /* comp: LE  */
#line 2405 "grammar.y"
                                { (yyval.param).comp = CMP_LE; }
#line 4377 "grammar.c"
    break;

  case 106: /* comp: GE  */
#line 2406 "grammar.y"
                                { (yyval.param).comp = CMP_GE; }
#line 4383 "grammar.c"
    break;

  case 107: /* dqual: %empty  */
#line 2410 "grammar.y"
                                { (yyval.param).direction = DIR_UNSPEC;  			 }
#line 4389 "grammar.c"
    break;

  case 108: /* dqual: SRC  */
#line 2411 "grammar.y"
                                { (yyval.param).direction = SOURCE;				 }
#line 4395 "grammar.c"
    break;

  case 109: /* dqual: DST  */
#line 2412 "grammar.y"
                                { (yyval.param).direction = DESTINATION;			 }
#line 4401 "grammar.c"
    break;

  case 110: /* dqual: SRC OR DST  */
#line 2413 "grammar.y"
                        { (yyval.param).direction = SOURCE_OR_DESTINATION;  }
#line 4407 "grammar.c"
    break;

  case 111: /* dqual: DST OR SRC  */
#line 2414 "grammar.y"
                        { (yyval.param).direction = SOURCE_OR_DESTINATION;  }
#line 4413 "grammar.c"
    break;

  case 112: /* dqual: SRC AND DST  */
#line 2415 "grammar.y"
                        { (yyval.param).direction = SOURCE_AND_DESTINATION; }
#line 4419 "grammar.c"
    break;

  case 113: /* dqual: DST AND SRC  */
#line 2416 "grammar.y"
                        { (yyval.param).direction = SOURCE_AND_DESTINATION; }
#line 4425 "grammar.c"
    break;

  case 114: /* dqual: IN  */
#line 2417 "grammar.y"
                                { (yyval.param).direction = DIR_IN;				 }
#line 4431 "grammar.c"
    break;

  case 115: /* dqual: OUT  */
#line 2418 "grammar.y"
                                { (yyval.param).direction = DIR_OUT;				 }
#line 4437 "grammar.c"
    break;

  case 116: /* dqual: IN SRC  */
#line 2419 "grammar.y"
                                { (yyval.param).direction = IN_SRC;				 }
#line 4443 "grammar.c"
    break;

  case 117: /* dqual: IN DST  */
#line 2420 "grammar.y"
                                { (yyval.param).direction = IN_DST;				 }
#line 4449 "grammar.c"
    break;

  case 118: /* dqual: OUT SRC  */
#line 2421 "grammar.y"
                                { (yyval.param).direction = OUT_SRC;				 }
#line 4455 "grammar.c"
    break;

  case 119: /* dqual: OUT DST  */
#line 2422 "grammar.y"
                                { (yyval.param).direction = OUT_DST;				 }
#line 4461 "grammar.c"
    break;

  case 120: /* dqual: PREV  */
#line 2423 "grammar.y"
                                { (yyval.param).direction = ADJ_PREV;				 }
#line 4467 "grammar.c"
    break;

  case 121: /* dqual: NEXT  */
#line 2424 "grammar.y"
                                { (yyval.param).direction = ADJ_NEXT;				 }
#line 4473 "grammar.c"
    break;

  case 122: /* inout: INGRESS  */
#line 2427 "grammar.y"
                        { (yyval.param).inout	= INGRESS;	}
#line 4479 "grammar.c"
    break;

  case 123: /* inout: EGRESS  */
#line 2428 "grammar.y"
                                { (yyval.param).inout	= EGRESS;   }
#line 4485 "grammar.c"
    break;

  case 124: /* acl: ACL  */
#line 2431 "grammar.y"
                                { (yyval.param).acl = ACL; 	}
#line 4491 "grammar.c"
    break;

  case 125: /* acl: ACE  */
#line 2432 "grammar.y"
                                        { (yyval.param).acl = ACE;		}
#line 4497 "grammar.c"
    break;

  case 126: /* acl: XACE  */
#line 2433 "grammar.y"
                                { (yyval.param).acl = XACE;	}
#line 4503 "grammar.c"
    break;

  case 127: /* expr: term  */
#line 2436 "grammar.y"
                        { (yyval.value) = (yyvsp[0].param).self;        }
#line 4509 "grammar.c"
    break;

  case 128: /* expr: expr OR expr  */
#line 2437 "grammar.y"
                        { (yyval.value) = Connect_OR((yyvsp[-2].value), (yyvsp[0].value));  }
#line 4515 "grammar.c"
    break;

  case 129: /* expr: expr AND expr  */
#line 2438 "grammar.y"
                        { (yyval.value) = Connect_AND((yyvsp[-2].value), (yyvsp[0].value)); }
#line 4521 "grammar.c"
    break;

  case 130: /* expr: NOT expr  */
#line 2439 "grammar.y"
                                        { (yyval.value) = Invert((yyvsp[0].value));			}
#line 4527 "grammar.c"
    break;

  case 131: /* expr: '(' expr ')'  */
#line 2440 "grammar.y"
                        { (yyval.value) = (yyvsp[-1].value); }
#line 4533 "grammar.c"
    break;

  case 132: /* expr: '(' expr ')' '%' STRING  */
#line 2441 "grammar.y"
                                        { 
		(yyval.value) = (yyvsp[-3].value); 
		if ( strlen((yyvsp[0].s)) > 16 ) {
			yyerror("Error: Maximum 16 chars allowed for flowlabel");
			YYABORT;
		} else {
			AddLabel((yyvsp[-3].value), (yyvsp[0].s));
		}
	}
#line 4547 "grammar.c"
    break;

  case 133: /* expr: '%' STRING '(' expr ')'  */
#line 2450 "grammar.y"
                                  { 
		(yyval.value) = (yyvsp[-1].value); 
		if ( strlen((yyvsp[-3].s)) > 16 ) {
			yyerror("Error: Maximum 16 chars allowed for flowlabel");
			YYABORT;
		} else {
			AddLabel((yyvsp[-1].value), (yyvsp[-3].s));
		}
	}
#line 4561 "grammar.c"
    break;


#line 4565 "grammar.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2461 "grammar.y"


static void  yyerror(char *msg) {

	if ( FilterFilename )
		snprintf(yyerror_buff, 255 ,"File '%s' line %d: %s at '%s'", FilterFilename, lineno, msg, yytext);
	else 
		snprintf(yyerror_buff, 255, "Line %d: %s at '%s'", lineno, msg, yytext);

	yyerror_buff[255] = '\0';
	fprintf(stderr, "%s\n", yyerror_buff);

} /* End of yyerror */

static uint32_t ChainHosts(uint64_t *offsets, uint64_t *hostlist, int num_records, int type) {
uint32_t offset_a, offset_b, i, j, block;
	if ( type == SOURCE ) {
		offset_a = offsets[0];
		offset_b = offsets[1];
	} else {
		offset_a = offsets[2];
		offset_b = offsets[3];
	}

	i = 0;
	block = Connect_AND(
				NewBlock(offset_b, MaskIPv6, hostlist[i+1] , CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(offset_a, MaskIPv6, hostlist[i] , CMP_EQ, FUNC_NONE, NULL )
			);
	i += 2;
	for ( j=1; j<num_records; j++ ) {
		uint32_t b = Connect_AND(
				NewBlock(offset_b, MaskIPv6, hostlist[i+1] , CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(offset_a, MaskIPv6, hostlist[i] , CMP_EQ, FUNC_NONE, NULL )
			);
		block = Connect_OR(block, b);
		i += 2;
	}

	return block;

} // End of ChainHosts

uint64_t VerifyMac(char *s) {
uint64_t mac;
size_t slen = strlen(s);
long l;
char *p, *q, *r;
int i;

	if ( slen > 17 )
		return 0; 

	for (i=0; i<slen; i++ ) {
		if ( !isxdigit(s[i]) && s[i] != ':' ) 
			return 0;
	}

	p = strdup(s);
	if ( !p ) {
		yyerror("malloc() error");
		return 0;
	}

	mac = 0;
	i = 0;	// number of MAC octets must be 6
	r = p;
	q = strchr(r, ':');
	while ( r && i < 6 ) {
		if ( q ) 
			*q = '\0';
		l = strtol(r, NULL, 16);
		if ( (i == 0 && errno == EINVAL) ) {
			free(p);
			return 0;
		}
		if ( l > 255 ) {
			free(p);
			return 0;
		}

		mac = ( mac << 8 ) | (l & 0xFF );
		i++;

		if ( q ) {
			r = ++q;
			q = strchr(r, ':');
		} else 
			r = NULL;
	}

	if ( i != 6 )
		return 0;

	return mac;

} // End of VerifyMac

static int InitSymbols(void) {
int i;

	// already initialised?
	if ( fwd_status )
		return 1;

	// fill fwd status cache table
	fwd_status = ( char **)calloc(256, sizeof(char *));
	if ( !fwd_status ) {
		fprintf(stderr, "malloc(): %s line %d: %s", __FILE__, __LINE__, strerror (errno));
		return 0;
	}
	i=0;
	while ( fwd_status_def_list[i].name ) {
		uint32_t j = fwd_status_def_list[i].id;
		fwd_status[j] = fwd_status_def_list[i].name;
		i++;
	}
	return 1;

} // End of InitSymbols

static uint32_t Get_fwd_status_id(char *status) {
int i;

	if ( !fwd_status && !InitSymbols() )
		yyerror("malloc() error");

	i = 0;
	while ( i < 256 ) {
		if ( fwd_status[i] && strcasecmp(fwd_status[i], status) == 0 ) 
			return i;
		i++;
	}
	return 256;

} // End of Get_fwd_status_id

static char *stripWord(char *word) {
	char *w = strdup(word);

	// strip ", ' and /' from begin/end of string
	if ( w[0] == 0x27 || w[0] == 0x22 || w[0] == 0x2f ) w++;
  size_t last = strlen(w) -1;

	if ( w[last] == 0x27 || w[last] == 0x22 || w[last] == 0x2f ) w[last] = '\0';

	return w;
} // End of stripWord

static int IsMD5(char *string) {

	int i = 0;
	for (i=0; i<32; i++) {
		char c = string[i];
		if ( c == '\0' || !isxdigit(c))
		return 0;
	}
	return string[i] == '\0';

} // End of IsMD5
